searchNodes=[{"doc":"PhxLiveStorybook provides a storybook-like UI interface for your Phoenix LiveView components. Explore all your components, and showcase them with different stories. Browse your component's documentation, with their supported attributes (coming in 0.3.0). Learn how components behave by using an interactive playground (coming in 0.3.0). How does it work? PhxLiveStorybook is mounted in your application router and serves its UI at the mounting point of your choice. It performs automatic discovery of your storybook content under a specified folder ( :content_path ) and then automatically generates a storybook navigation sidebar. Every module detected in your content folder will be loaded and identified as a storybook entry. Three kinds of entries are supported: component to describe your stateless function components or your live_components. page to write &amp; document UI guidelines, or whatever content you want. example to show how your components can be used and mixed in real UI pages. (not available now) Almost everything, from sidebar rendering to component preview, is performed at compilation time. Installation To start using PhxLiveStorybook in your phoenix application you will need to follow these steps: Add the phx_live_storybook dependency Create your storybook backend module Add storybook access to your router Make your components assets available Configure your storybook Create some content. 1. Add the phx_live_storybook dependency Add the following to your mix.exs and run mix deps.get: def deps do [ { :phx_live_storybook , &quot;~&gt; 0.3.0&quot; } ] end 2. Create your storybook backend module Create a new module under your application lib folder. # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhxLiveStorybook , otp_app : :my_app end This backend module ensures the storybook gets recompiled as soon as you update your storybook content (see section 5.) 3. Add storybook access in your router Once installed, update your router's configuration to forward requests to a PhxLiveStorybook with a unique name of your choosing: # lib/my_app_web/router.ex use MyAppWeb , :router import PhxLiveStorybook.Router ... # outside of your main scope &amp; of your :browser pipeline live_storybook &quot;/storybook&quot; , otp_app : :my_app , backend_module : MyAppWeb.Storybook 4. Make your components assets available Build a new CSS bundle dedicated to your live_view components: this bundle will be used both by your app and the storybook. In this README, we use assets/css/my_components.css as an example. If your components require any hooks or custom uploaders, declare them as such in a new JS bundle: // assets/js/my_components.js import * as Hooks from &quot;./hooks&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Uploaders }; })(); ℹ️ Learn more on this topic in the sandboxing guide . 5. Configure your storybook In your configuration files, add the following. # config/config.exs config :my_app , MyAppWeb.Storybook , content_path : Path . expand ( &quot;../storybook&quot; , __DIR__ ) , css_path : &quot;/assets/my_components.css&quot; , js_path : &quot;/assets/my_components.js&quot; 6. Create some content. Then you can start creating some content for your storybook. Storybook can contain 2 different kinds of entries : component entries : to document and showcase your components across different stories (ie. variants ) pages : to publish some UI guidelines, framework or whatever with regular HTML content. examples : to show how your components can be used and mixed in real UI pages. As of 0.3.0 , only component and page entries are available. Entries are described as Elixir scripts ( .exs ) created under your :content_path folder. Feel free to organize them in sub-folders, as the hierarchy will be respected in your storybook sidebar. Here is an example of a stateless (function) component entry: # storybook/components/button.exs defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button # :live_component or :page are also available use PhxLiveStorybook.Entry , :component def function , do : &amp; Button . button / 1 def description , do : &quot;A simple generic button.&quot; def stories do [ % Story { id : :default , attributes : %{ label : &quot;A button&quot; } } , % Story { id : :green_button , attributes : %{ label : &quot;Still a button&quot; , color : :green } } ] end end Configuration All config settings, only the :content_path key is mandatory. # config/config.exs config :my_app , MyAppWeb.Storybook , # Path to your storybook entries (required). content_path : Path . expand ( &quot;../storybook&quot; , __DIR__ ) , # Path to your components stylesheet. css_path : &quot;/assets/my_components.css&quot; , # Path to your JS asset, which will be loaded just before PhxLiveStorybook&#39;s own # JS. It&#39;s mainly intended to define your LiveView Hooks in `window.storybook.Hooks`. js_path : &quot;/assets/my_components.js&quot; , # Custom storybook title. Default is &quot;Live Storybook&quot;. title : &quot;My Live Storybook&quot; , # Folder settings. # Each folder is designated by its relative path from the storybook mounting point. # For each folder you can: # - make it open by default in the sidebar, with `open: true`. # - give it a custom name in the sidebar # - give it a custom icon in the sidebar, with a FontAwesome 6+ CSS class. folders : [ &quot;/&quot; : [ icon : &quot;fas fa-banana&quot; ] , &quot;/components&quot; : [ icon : &quot;far fa-toolbox&quot; , open : true ] , &quot;components/live&quot; : [ icon : &quot;fal fa-bolt&quot; , name : &quot;Live!!!&quot; ] ]","ref":"PhxLiveStorybook.html","title":"PhxLiveStorybook","type":"module"},{"doc":"An attr is one of your component attributes. Its structure mimics forthcoming LiveView 0.18.0 declarative assigns. Attributes declaration will populate the Playground tab of your storybook, for each of your components. Supported keys: id : the attribute id (required). Should match to your component assign. type : the attribute type (required). But be one of: :any - any term :string - any binary string :atom - any atom :boolean - any boolean :integer - any integer :float - any float :list - a List of any arbitrary types :block - a block (you can only declare one) :slots - a list of slots Any struct module required : true if the attribute is mandatory. doc : a text documentation for this attribute. default : attribute default value.","ref":"PhxLiveStorybook.Attr.html","title":"PhxLiveStorybook.Attr","type":"module"},{"doc":"Behaviour implemented by your backend module. Most of it is precompiled through macros.","ref":"PhxLiveStorybook.BackendBehaviour.html","title":"PhxLiveStorybook.BackendBehaviour","type":"behaviour"},{"doc":"Returns the all leaves of the storybook content tree (ie. whichever entries are is not a folder)","ref":"PhxLiveStorybook.BackendBehaviour.html#c:all_leaves/0","title":"PhxLiveStorybook.BackendBehaviour.all_leaves/0","type":"callback"},{"doc":"Returns a configuration value from your config.exs storybook settings. key is the config key default is an optional default value if no value can be fetched.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:config/2","title":"PhxLiveStorybook.BackendBehaviour.config/2","type":"callback"},{"doc":"Returns a precompiled tree of your storybook entries.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:entries/0","title":"PhxLiveStorybook.BackendBehaviour.entries/0","type":"callback"},{"doc":"Returns an entry from its absolute path.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:find_entry_by_path/1","title":"PhxLiveStorybook.BackendBehaviour.find_entry_by_path/1","type":"callback"},{"doc":"Renders code snippet of a specific story for a given component entry. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_code/2","title":"PhxLiveStorybook.BackendBehaviour.render_code/2","type":"callback"},{"doc":"Renders a tab content for a page entry. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_page/2","title":"PhxLiveStorybook.BackendBehaviour.render_page/2","type":"callback"},{"doc":"Renders source of a component entry. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_source/1","title":"PhxLiveStorybook.BackendBehaviour.render_source/1","type":"callback"},{"doc":"Renders a specific story for a given component entry. Can be a single story or a story group. Returns rendered HEEx template.","ref":"PhxLiveStorybook.BackendBehaviour.html#c:render_story/2","title":"PhxLiveStorybook.BackendBehaviour.render_story/2","type":"callback"},{"doc":"An entry designates any kind of content in your storybook. For now only following kinds of entries are supported: component , :live_component , and :page . In order to populate your storybook, just create entry scripts under your content path, and implement their required behaviour. Entries must be created as .exs files. Usage Component Implement your component as such. Confer to: PhxLiveStorybook.Story documentation for stories. PhxLiveStorybook.Attr documentation for attributes. # storybook/my_component.exs defmodule MyAppWeb.Storybook.MyComponent do use PhxLiveStorybook.Entry , :component # required def function , do : &amp; MyAppWeb.MyComponent . my_component / 1 def name , do : &quot;Another name for my component&quot; def description , do : &quot;My component description&quot; def icon , do : &quot;fa fa-icon&quot; def attributes , do : [ ] def stories , do : [ ] end Live Component Very similar components, excepted you need to define a component/0 function instead of function/0 . # storybook/my_live_component.exs defmodule MyAppWeb.Storybook.MyLiveComponent do use PhxLiveStorybook.Entry , :live_component # required def component , do : MyAppWeb.MyLiveComponent def name , do : &quot;Another name for my component&quot; def description , do : &quot;My live component description&quot; def icon , do : &quot;fa fa-icon&quot; def attributes , do : [ ] def stories , do : [ ] end Page A page is a fairly simple entry that can be used to write whatever content you want. We use it to provide some UI guidelines. You should implement the render function and an optional navigation function, if you want a tab based sub-navigation. Current tab is passed as :tab in render/1 assigns. # storybook/my_page.exs defmodule MyAppWeb.Storybook.MyPage do use PhxLiveStorybook.Entry , :page def name , do : &quot;Another name for my page&quot; def description , do : &quot;My page description&quot; def icon , do : &quot;fa fa-icon&quot; def navigation do [ { :tab_id , &quot;Tab Name&quot; , &quot;tab-icon&quot; } , { :tab_id , &quot;Tab Name&quot; , &quot;tab-icon&quot; } ] end def render ( assigns ) do ~H&quot;&quot;&quot; &lt;div&gt;Your HEEX template&lt;/div&gt; &quot;&quot;&quot; end end","ref":"PhxLiveStorybook.Entry.html","title":"PhxLiveStorybook.Entry","type":"module"},{"doc":"Convenience helper for using the functions above.","ref":"PhxLiveStorybook.Entry.html#__using__/1","title":"PhxLiveStorybook.Entry.__using__/1","type":"macro"},{"doc":"Responsible for rendering your components code snippet, for a given PhxLiveStorybook.Story . Uses Makeup libray for syntax highlighting.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html","title":"PhxLiveStorybook.Rendering.CodeRenderer","type":"module"},{"doc":"Renders a component code snippet, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_component_code/5","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_component_code/5","type":"function"},{"doc":"Renders a component's (live or not) source code, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_component_source/2","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_component_source/2","type":"function"},{"doc":"Renders a Story (or StoryGroup ) code snippet, wrapped in a &lt;pre&gt; tag.","ref":"PhxLiveStorybook.Rendering.CodeRenderer.html#render_story_code/3","title":"PhxLiveStorybook.Rendering.CodeRenderer.render_story_code/3","type":"function"},{"doc":"Responsible for rendering your function &amp; live components, for a given PhxLiveStorybook.Story or PhxLiveStorybook.StoryGroup .","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html","title":"PhxLiveStorybook.Rendering.ComponentRenderer","type":"module"},{"doc":"Renders a component.","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html#render_component/5","title":"PhxLiveStorybook.Rendering.ComponentRenderer.render_component/5","type":"function"},{"doc":"Renders a story or a group of story for a component.","ref":"PhxLiveStorybook.Rendering.ComponentRenderer.html#render_story/3","title":"PhxLiveStorybook.Rendering.ComponentRenderer.render_story/3","type":"function"},{"doc":"Provides LiveView routing for storybook.","ref":"PhxLiveStorybook.Router.html","title":"PhxLiveStorybook.Router","type":"module"},{"doc":"Defines a PhxLiveStorybook route. It expects the path the storybook will be mounted at and a set of options. This will also generate a named helper called live_dashboard_path/2 which you can use to link directly to the dashboard, such as: &lt; % = link &quot;Storybook&quot; , to : live_storybook_path ( conn , :root ) % &gt; Note you should only use link/2 to link to the storybook (and not live_redirect/live_link , as it has to set its own session on first render. Options :otp_app - Required - OTP Name of your Phoenix application. It must match :otp_app of your backend module and settings. :backend_module - Required - Name of your backend module. :live_socket_path - Configures the socket path. It must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint. Usage # lib/my_app_web/router.ex use MyAppWeb , :router import PhxLiveStorybook.Router ... scope &quot;/&quot; do pipe_through :browser live_storybook &quot;/storybook&quot; , otp_app : :my_app , backend_module : MyAppWeb.Storybook end","ref":"PhxLiveStorybook.Router.html#live_storybook/2","title":"PhxLiveStorybook.Router.live_storybook/2","type":"macro"},{"doc":"A story captures the rendered state of a UI component. Developers write multiple stories per component that describe all the “interesting” states a component can support. Each story will be displayed in the storybook as a code snippet alongside with the component preview. Usage def stories do [ % Story { id : :default , description : &quot;Default dropdown&quot; , attributes : %{ label : &quot;A dropdown&quot; , } , slots : [ ~s|&lt;:entry path=&quot;#&quot; label=&quot;Account settings&quot;/&gt;| , ~s|&lt;:entry path=&quot;#&quot; label=&quot;Support&quot;/&gt;| , ~s|&lt;:entry path=&quot;#&quot; label=&quot;License&quot;/&gt;| ] } ] end","ref":"PhxLiveStorybook.Story.html","title":"PhxLiveStorybook.Story","type":"module"},{"doc":"A story group is a set of similar stories that will be rendered together in a single preview &lt;pre&gt; block. Usage def stories do [ % StoryGroup { id : colors , description : &quot;Different color buttons&quot; , stories : [ % Story { id : :blue_button , attributes : %{ label : &quot;A button&quot; , color : :blue } } , % Story { id : :red_button , attributes : %{ label : &quot;A button&quot; , color : :red } } , % Story { id : :green_button , attributes : %{ label : &quot;A button&quot; , color : :green } } ] } ] end","ref":"PhxLiveStorybook.StoryGroup.html","title":"PhxLiveStorybook.StoryGroup","type":"module"},{"doc":"In PhxLiveStorybook your components live within the storybook, so they share some context with the storybook: styling and scripts . While the original Storybook for React only relies on iframes , we found them quite slow and don't want them to be the default choice. This guide will explain : what JS context do your components share with the storybook? how is the storybook styled, to prevent most styling clashes? how you should provide the style of your components with scoped styles. how, as a last resort, you can enable iframe rendering.","ref":"sandboxing.html","title":"Sandboxing components","type":"extras"},{"doc":"PhxLiveStorybook runs with Phoenix LiveView and therefore requires its LiveSocket . This LiveSocket is the same used by your components: you just need to inject it with your own Hooks and Uploaders . To do so, create a JS file that will declare your Hooks and Uploaders and set them in window.storybook . This script will be loaded immediately before the storybook's script. // assets/js/my_components.js import * as Hooks from &quot;./hooks&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Uploaders }; })(); Then set the js_path: &quot;/assets/js/components.js&quot; option to the storybook within your config.exs file. You can also use this script to inject whatever content you want into document HEAD , such as external scripts.","ref":"sandboxing.html#1-what-js-context-do-your-components-share-with-the-storybook","title":"Sandboxing components - 1. What JS context do your components share with the storybook?","type":"extras"},{"doc":"PhxLiveStorybook is using TailwindCSS with preflight (which means all default HTML styles from your browser are removed) and a custom prefix : lsb- . (which means that instead of using bg-blue-400 the storybook uses lsb-bg-blue-400 ). Only elements with the .lsb class are preflighted, in order to let your component styling as-is. So unless your components use lsb or lsb- prefixed classes there should be no styling leak from the storybook to you components.","ref":"sandboxing.html#2-how-is-the-storybook-styled","title":"Sandboxing components - 2. How is the storybook styled?","type":"extras"},{"doc":"You need to inject your component's stylesheets into the storybook. Just (like for JS), set the css_path: &quot;/assets/css/components.css&quot; option in config.exs . The last part (2.) was about storybook styles not leaking into your components. This part is about the opposite: don't accidentally mess up Storybook styling with your styles. All containers rendering your components in the storybook ( stories , playground , pages ...) have the .lsb-sandbox CSS class. You can leverage this to scope your styles with this class. Here is how you can do it with TailwindCSS : use Tailwind important selector strategy with this class. It will prefix all your tailwind classes with .lsb-sandbox increasing their specificity, hence their priority. // assets/tailwind.config.js module.exports = { // ... important: &quot;.lsb-sandbox&quot;, }; nest your custom styles under Tailwind @layer utilities . This way, your styling will also benefit from .lsb-sandbox scoping. /* assets/css/components.css */ @tailwind base; @tailwind components; @tailwind utilities; @layer utilities { /* this style will be generated as .lsb-sandbox * { ... } */ * { font-family: &quot;MyComponentsFont&quot;; @apply text-slate-600; } /* this style will be generated as .lsb-sandbox h1 { ... } */ h1 { @apply text-2xl font-bold text-slate-700 mt-2 mb-6; } /* this style will be generated as .lsb-sandbox h2 { ... } */ h2 { @apply text-xl font-bold text-slate-700 mt-2 mb-4; } }","ref":"sandboxing.html#3-how-you-should-provide-the-style-of-your-components","title":"Sandboxing components - 3. How you should provide the style of your components?","type":"extras"},{"doc":"As a last resort, if for whatever reason you cannot make your component live within the storybook (an example would be that your component needs to bind listeners on document ), it is possible to enable iframe rendering, component per component. Just add the iframe option to it. # storybook/components/button.exs defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button use PhxLiveStorybook.Entry , :component def function , do : &amp; Button . button / 1 def container , do : :iframe # ... end","ref":"sandboxing.html#4-enable-iframe-rendering","title":"Sandboxing components - 4. Enable iframe rendering","type":"extras"}]